/* dyn4exec.c -- change existing file to ET_DYN from ET_EXEC
   Copyright 2001 BitWagon Software LLC.  All rights reserved.
   This file may be used, modified, and distributed under the terms
   of the GNU General Public License version 2.
*/
#include <elf.h>
#include <sys/mman.h>
#include <fcntl.h>

int
main(int argc, char const *const *const argv)
{
	int const fd = open(argv[1], O_RDWR, 0);
	Elf32_Ehdr *const ehdr = (Elf32_Ehdr *)mmap(0, 4096,
		PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
	if (ehdr->e_type!=ET_EXEC) {
		return 1;
	}
	ehdr->e_type = ET_DYN;
	return 0;
}

