/* veclib.h -- utility functions for transfer vectors
   Copyright 2000,2001 BitWagon Software LLC.  All rights reserved.
   This file may be used, modified, and distributed under the terms
   of the GNU General Public License version 2.
*/
#ifndef _h_veclib_h  /*{*/
#define _h_veclib_h

#include <elf.h>
#include <regex.h>

extern char const *const * find_outfn(char const *const *const argv);

extern void free_symbol_patterns(regex_t *patterns);

extern regex_t *get_symbol_patterns(char *arg, int no_regex);

extern char const *const *get_tokens(
	char *const arg,
	size_t const size,
	int *n_tokens
);

extern char const * get_vecname(
	char const *const strtab,
	Elf32_Dyn const *const dynamic,
	char const *const libfn
);

extern regex_t *make_regex(
	char const *const *tokens,
	int n_tokens
);

extern int matches(
	char const *const name,
	regex_t const *pat  /* array of patterns */
);

extern void veclib_retrofit(
	int const fdo,
	Elf32_Ehdr *const ehdr,
	char *const ante_hash,
	size_t const sz_ante_hash,
	unsigned *const new_htab,
	Elf32_Sym *const post_sym,
	int n_post_sym
);

#endif  /*}*/
